import cx from 'classnames';
import PropTypes from 'prop-types';
import { CLASS_BAR, CLASS_STEP, CLASS_STEP_NUMBER, CLASS_STEP_ICON, CLASS_STEP_DESCRIPTION, STATUSES, getStatusClass } from './config.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";

var MoleculeProgressStep = function MoleculeProgressStep(_ref) {
  var status = _ref.status,
      icon = _ref.icon,
      label = _ref.label,
      numStep = _ref.numStep,
      lastStep = _ref.lastStep,
      compressed = _ref.compressed;

  var _getStatusClass = getStatusClass(status),
      CLASS_STEP_STATUS = _getStatusClass[0],
      CLASS_BAR_STATUS = _getStatusClass[1];

  var bar = /*#__PURE__*/_jsx("hr", {
    className: cx(CLASS_BAR, CLASS_BAR_STATUS)
  });

  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [!compressed && /*#__PURE__*/_jsxs("div", {
      className: cx(CLASS_STEP, CLASS_STEP_STATUS),
      children: [icon ? /*#__PURE__*/_jsx("div", {
        className: CLASS_STEP_ICON,
        children: icon
      }) : /*#__PURE__*/_jsx("p", {
        className: CLASS_STEP_NUMBER,
        children: numStep
      }), /*#__PURE__*/_jsx("p", {
        className: CLASS_STEP_DESCRIPTION,
        children: label
      })]
    }), !lastStep ? bar : compressed && bar]
  });
};

export default MoleculeProgressStep;
export { STATUSES };