import { Children, cloneElement, useRef } from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import { BASE_CLASS, CLASS_STEPS, CLASS_CONTENT, CLASS_COMPRESSED_INFO, CLASS_VERTICAL, CLASS_COMPRESSED, PROGRESS_BAR_JUSTIFY_CONTENT, CONTENT_STYLE } from './config.js';
import MoleculeProgressStep, { STATUSES } from './components/MoleculeProgressStep/index.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var MoleculeProgressSteps = function MoleculeProgressSteps(_ref) {
  var _cx, _cx4, _cx5;

  var vertical = _ref.vertical,
      children = _ref.children,
      iconStepDone = _ref.iconStepDone,
      compressed = _ref.compressed,
      _ref$progressBarJusti = _ref.progressBarJustifyContent,
      progressBarJustifyContent = _ref$progressBarJusti === void 0 ? PROGRESS_BAR_JUSTIFY_CONTENT.LEGACY : _ref$progressBarJusti,
      _ref$contentStyle = _ref.contentStyle,
      contentStyle = _ref$contentStyle === void 0 ? CONTENT_STYLE.FIXED : _ref$contentStyle;
  var activeStepContent = useRef();
  var className = cx(BASE_CLASS, (_cx = {}, _cx[CLASS_VERTICAL] = vertical, _cx[CLASS_COMPRESSED] = compressed, _cx));
  var compressedInfoSteps = Children.toArray(children).filter(Boolean).map(function (child, index, children) {
    var _cx2;

    var _child$props = child.props,
        label = _child$props.label,
        status = _child$props.status;
    var totalSteps = children.length;
    return /*#__PURE__*/_jsx("div", {
      className: cx(CLASS_COMPRESSED_INFO + "-item", (_cx2 = {}, _cx2[CLASS_COMPRESSED_INFO + "-item--active"] = status === STATUSES.ACTIVE, _cx2)),
      children: index + 1 + "/" + totalSteps + ": " + label
    }, index);
  });
  var extendedChildren = Children.toArray(children).filter(Boolean).map(function (child, index, children) {
    var _child$props2 = child.props,
        iconChild = _child$props2.icon,
        iconActive = _child$props2.iconActive,
        status = _child$props2.status,
        childrenChild = _child$props2.children;
    var totalChildren = children.length;
    var numStep = index + 1;
    var lastStep = index >= totalChildren - 1;
    var isVisited = status === STATUSES.VISITED;
    var isActive = status === STATUSES.ACTIVE;
    var icon = iconChild;
    if (isVisited) icon = iconStepDone;

    if (isActive) {
      icon = iconActive || iconChild;
      activeStepContent.current = childrenChild;
    }

    return /*#__PURE__*/cloneElement(child, {
      numStep: numStep,
      lastStep: lastStep,
      icon: icon,
      progressBarJustifyContent: progressBarJustifyContent,
      compressed: compressed
    });
  });
  var childrenContent = Children.toArray(children).filter(Boolean).map(function (child, index, children) {
    var _cx3;

    var _child$props3 = child.props,
        childrenChild = _child$props3.children,
        status = _child$props3.status;
    return /*#__PURE__*/_jsx("div", {
      className: cx(CLASS_CONTENT + "-item", (_cx3 = {}, _cx3[CLASS_CONTENT + "-item--active"] = status === STATUSES.ACTIVE, _cx3)),
      children: childrenChild
    }, index);
  });
  return /*#__PURE__*/_jsxs("div", {
    className: className,
    children: [compressed && /*#__PURE__*/_jsx("div", {
      className: cx(CLASS_COMPRESSED_INFO, (_cx4 = {}, _cx4[CLASS_COMPRESSED_INFO + "--justifyContent-" + progressBarJustifyContent] = progressBarJustifyContent, _cx4)),
      children: compressedInfoSteps
    }), /*#__PURE__*/_jsx("div", {
      className: cx(CLASS_STEPS, (_cx5 = {}, _cx5[CLASS_STEPS + "--justifyContent-" + progressBarJustifyContent] = progressBarJustifyContent, _cx5)),
      children: extendedChildren
    }), /*#__PURE__*/_jsx("div", {
      className: cx(CLASS_CONTENT, contentStyle),
      children: childrenContent
    })]
  });
};

MoleculeProgressSteps.displayName = 'MoleculeProgressSteps';
export default MoleculeProgressSteps;
export { MoleculeProgressStep, STATUSES, STATUSES as moleculeProgressStepsStatuses, PROGRESS_BAR_JUSTIFY_CONTENT as moleculeProgressStepsJustifyContentBar, CONTENT_STYLE as moleculeProgressContentStyle };